import { CipherCCM, CipherGCM, DecipherCCM, DecipherGCM } from 'node:crypto';

interface INanoAESCipherOpt {
    mode: "cbc" | "ctr" | "gcm";
    keySize: 128 | 192 | 256;
}
type AuthenticatedCipher = CipherCCM | CipherGCM;
type AuthenticatedDecipher = DecipherCCM | DecipherGCM;
declare class NanoAES {
    private readonly key;
    opt: INanoAESCipherOpt;
    algorithm: string;
    constructor(key: string, opt: INanoAESCipherOpt);
    encrypt(data: Buffer | string): Buffer;
    decrypt(encryptedData: Buffer): Buffer;
    private isAuthenticated;
    static generateKey(size: 128 | 192 | 256): Buffer;
}

export { type AuthenticatedCipher, type AuthenticatedDecipher, type INanoAESCipherOpt, NanoAES };
